#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <string.h>
#include <sys/errno.h>

#include "lcd.h"

#include "drv_base.h"
#include "MtxOrb.h"
#include "text.h"
#include "debug.h"
#include "curses_drv.h"

// TODO: Add DOS/Windows support...


lcd_logical_driver lcd;

lcd_physical_driver drivers[] =
{
  { "MtxOrb", MtxOrb_init, },
  { "text",   text_init, },
  { "debug",   debug_init, },
  { "curses", curses_drv_init, },
  { NULL, NULL, },
  
};



////////////////////////////////////////////////////////////
// This sets up which driver to use and initializes stuff.
// 
// It should not be messed with, except to add new drivers.
//
int lcd_init(char *device, char *driver)
{
  int i;

  lcd.framebuf = NULL;
  
  drv_base_init(device);

  for(i=0; drivers[i].name; i++)
  {
    if(!strcmp(driver, drivers[i].name))
    {
      return drivers[i].init(device);
    }
  }

  printf("Invalid driver: %s\n", driver);
  return -1;
  
}

